# -*- coding: utf-8 -*-
import struct
import wave
import numpy as np
import scipy.signal
from pylab import *
import pyaudio
import scipy.fftpack
import time
pa = pyaudio.PyAudio()

#unichr(int(format(ord(u"あ"),"b"),2)).encode("utf-8")

def fft(x, fs):
    x = list(x)
    N = 1024

    for i in range(N):
        #b.append(0.0)
        x.append(0.0)
        
    start = 0
    X = np.fft.fft(x[start:start+N])
    #X = scipy.fftpack.fft(x[start:start+N])         # scipy

    freqList = np.fft.fftfreq(N, d=1.0/fs)
    #freqList = scipy.fftpack.fftfreq(N, d=1.0/ fs)  # scipy

    amplitudeSpectrum = [np.sqrt(c.real ** 2 + c.imag ** 2) for c in X]

    subplot(311)
    plot(range(start, start+N), x[start:start+N])
    axis([start, start+N, -1.0, 1.0])
    xlabel("time [sample]")
    ylabel("amplitude")

    subplot(312)
    plot(freqList, amplitudeSpectrum, marker= 'o', linestyle='-')
    axis([0, fs/2, 0, 50])
    xlabel("frequency [Hz]")
    ylabel("amplitude spectrum")
    spec = amplitudeSpectrum
    if abs(spec.index(max(spec)) - 10) < 2 and max(spec) / 4 > np.std(spec[5:20]) and max(spec) > 20:
		 #show()
		 pass
    return(amplitudeSpectrum)
    
class Fsk:
	def __init__(self):
		self.hz = 882
		self.standard = []
		self.strong = 0
		self.weak = 0

		#self.gap90 = csv.reader(open("90.csv", 'rb'))
		#self.gap180 = csv.reader(open("180.csv", 'rb'))
		#self.gap270 = csv.reader(open("270.csv", 'rb'))
		
	def decode(self):
		amplitude = 0
		x = []
		x.append(list(frombuffer(self.stream.read(1),dtype = "int16") / 32768.0)[0])
		x.append(list(frombuffer(self.stream.read(1),dtype = "int16") / 32768.0)[0])
		x.append(list(frombuffer(self.stream.read(1),dtype = "int16") / 32768.0)[0])
		for er in range(100):
			x.append(list(frombuffer(self.stream.read(1),dtype = "int16") / 32768.0)[0])
			if (x[len(x) - 2] > x[len(x) - 1])  != (x[len(x) - 3] > x[len(x) - 2]):
				v = []
				v.append(list(frombuffer(self.stream.read(1),dtype = "int16") / 32768.0)[0])
				v.append(list(frombuffer(self.stream.read(1),dtype = "int16") / 32768.0)[0])
				v.append(list(frombuffer(self.stream.read(1),dtype = "int16") / 32768.0)[0])
				while (v[len(v) - 2] > v[len(v) - 1])  == (v[len(v) - 3] > v[len(v) - 2]):
					v.append(list(frombuffer(self.stream.read(1),dtype = "int16") / 32768.0)[0])
				break
		amplitude = abs(max(x)) + abs(min(v))
		print len(v)
		return(amplitude)
		
	def decode2bin(self):
		amplitude = self.decode()
		if amplitude > self.strong * 0.6:
			return("0")
		elif amplitude > self.weak * 0.5:
			return("1")
		else:
			return("")
			#print "error"
			#exit()
			
	def main(self, max_strength):
		decoded = []
		plus = []
		delay = 0
		x = []
		strength_pre = 0
		strength_post = 0
		tmpbin = ""
		
		self.decode()
		first = self.decode()
		second = self.decode()
		
		if first > second:#基準となる振幅の取得
			self.strong = first
			self.weak = second
		elif second > first:
			self.strong = second
			self.weak = first
		
		datasizebin = ""
		"""
		for cnt in range(16):
			print self.decode2bin()
		
		
		for cnt in range(100):
			print self.decode2bin()
		time.sleep(100)
		"""
		while True:
			if self.decode2bin() == "1":
				if self.decode2bin() == "1":
					break
		print "start"
		for cnt in range(32):#データのサイズを取得
			datasizebin = datasizebin + self.decode2bin()
		print datasizebin
		datasize = int(datasizebin, 2)
		print datasize
		
		decoded = ""
		decoded_text = ""
		for we in range(datasize/8):
			decoded = ""
			while len(decoded) < 8:
				decoded = decoded + self.decode2bin()
			print int(decoded, 2)
			decoded_text = decoded_text + chr(int(decoded, 2))
			print chr(int(decoded, 2))
			print decoded
		print decoded_text
		savefile = open("recv.html","wb")
		savefile.write(decoded_text)
		savefile.close()
			
		"""
		for we in range(1000):
			x = []
			x.append(list(frombuffer(self.stream.read(1),dtype = "int16") / 32768.0)[0])
			x.append(list(frombuffer(self.stream.read(1),dtype = "int16") / 32768.0)[0])
			for er in range(100):
				x.append(list(frombuffer(self.stream.read(1),dtype = "int16") / 32768.0)[0])
				#if (abs(x[len(x) - 2] - x[len(x) - 1]) == (x[len(x) - 2] - x[len(x) - 1])) == (abs(x[len(x) - 3] - x[len(x) - 2]) == (x[len(x) - 3] - x[len(x) - 2])):
				#print (x[len(x) - 2] > x[len(x) - 1]) 
				#print (x[len(x) - 3] > x[len(x) - 2])
				#time.sleep(0.1)
				if (x[len(x) - 2] > x[len(x) - 1])  != (x[len(x) - 3] > x[len(x) - 2]):
					v = []
					v.append(list(frombuffer(self.stream.read(1),dtype = "int16") / 32768.0)[0])
					v.append(list(frombuffer(self.stream.read(1),dtype = "int16") / 32768.0)[0])
					v.append(list(frombuffer(self.stream.read(1),dtype = "int16") / 32768.0)[0])
					v.append(list(frombuffer(self.stream.read(1),dtype = "int16") / 32768.0)[0])
					while (v[len(v) - 2] > v[len(v) - 1])  == (v[len(v) - 3] > v[len(v) - 2]):
						#print 1
						v.append(list(frombuffer(self.stream.read(1),dtype = "int16") / 32768.0)[0])
					x.append(123)
					#print x + [12345] + v
					#print len(v)
					#print len(v)
					if max(x) + abs(min(v)) > 90:
						decoded.append(None)
						#decoded.append(None)
					elif max(x) + abs(min(v)) > 90:
						decoded.append(882)
						#decoded.append(1)
						#decoded.append(0)
					elif max(x) + abs(min(v)) > 90:
						decoded.append(1470)
						#decoded.append(1)
						#decoded.append(1)
					else:
						decoded.append(None)
						#decoded.append(None)
						#decoded.append(None)
					break 
				#print decoded
		print decoded
		"""
		time.sleep(1000)
			
if __name__ == '__main__':
    stream = pa.open(format = pyaudio.paInt16,channels = 1, rate = 44100, input = True,output = True,frames_per_buffer = 1024)
    fsk = Fsk()
    fsk.stream = stream
    sig = 3
    while True:
        x = frombuffer(stream.read(2205),dtype = "int16") / 32768.0
        spec = fft(x, 44100)
        #spec = [int(q) for q in spec]
        #print spec
        #print spec[20]
        if abs(spec.index(max(spec)) - 10) < 2 and max(spec) / 4 > np.std(spec[5:20]) and max(spec) > 20:
			print "Start!"
			max_strength = max(list(x))#最大値取得
			x = list(frombuffer(stream.read(100),dtype = "int16") / 32768.0)
			while max(x) > 0.1:#無音になるまで待つ
				x = list(frombuffer(stream.read(100),dtype = "int16") / 32768.0)
			print max(x)
			print max_strength
			print "ahaha"
			x = float(frombuffer(stream.read(1),dtype = "int16") / 32768.0)
			while abs(x) < max_strength * 0.5:#無音が終わるまで待つ
				x = float(frombuffer(stream.read(1),dtype = "int16") / 32768.0)
				print x
			print np.average(x)
			print "end"

			if abs(x) == x:
				peak = True
			else:
				peak = False

			for cnt in [1,2]:
				sig = peak
				while sig == peak:
					x = float(frombuffer(stream.read(1),dtype = "int16") / 32768.0)
					if abs(x) == x:
						sig = True
					else:
						sig = False
					print x
				if peak == True:
					peak = False
				else:
					peak = True
			#print 222
			#time.sleep(100)

			fsk.main(abs(max_strength))
